#property copyright "Discussion"
#property link      "https://www.mql5.com/en/forum/450830"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_plots   3
//--- plot Buy
#property indicator_label1  "Buy"
#property indicator_type1   DRAW_ARROW
#property indicator_color1  clrDeepSkyBlue
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- plot Sell
#property indicator_label2  "Sell"
#property indicator_type2   DRAW_ARROW
#property indicator_color2  clrDarkGray
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
//--- MA (hidden)
#property indicator_type3   DRAW_LINE
#property indicator_color3  clrNONE
#property indicator_style3  STYLE_SOLID
#property indicator_label3  "MALine"
#property indicator_width3  1
//--- indicator buffers
double         BuyBuffer[];
double         SellBuffer[];
double maBuffer[]; // Moving Average buffer value
double indvalue[];
int ma_handle = INVALID_HANDLE;
int max_bars;
ENUM_TIMEFRAMES prevPeriod = PERIOD_CURRENT;

int ma_point_range = 150; // Stabilize signal distance to the MA

//we create a structure for the engulf 
class anEngulf{
         //discovery time 
datetime discoveryTime;
datetime bar1Time,bar2Time;
double   top,bottom;
bool     active;
char     direction;//-1 bearish 1 bullish 0 nothing
         public:
         anEngulf(void){reset();}
        ~anEngulf(void){reset();}
    void reset(){
         discoveryTime=0;
         bar1Time=0;
         bar2Time=0;
         top=0.0;
         bottom=0.0;
         direction=0;
         active=false;
         }
    void setup_bullish(datetime _now,
                       datetime _bar1,
                       datetime _bar2,
                       double _top,
                       double _bottom){
         direction=1;
         top=_top;
         bottom=_bottom;
         bar1Time=_bar1;
         bar2Time=_bar2;
         discoveryTime=_now;
         active=true;
         }
    void setup_bearish(datetime _now,
                       datetime _bar1,
                       datetime _bar2,
                       double _top,
                       double _bottom){
         direction=-1;
         top=_top;
         bottom=_bottom;
         bar1Time=_bar1;
         bar2Time=_bar2;
         discoveryTime=_now;
         active=true;
         }  
    bool is_active(){return(active);}
    char maintain(double _close,datetime _now){
         if(_now>=discoveryTime){
           //bullish
           // If the current price of the current candle (third candle) is higher than the top of the engulfing pattern, the pattern is invalidated (active=false) and a Buy signal is returned (1)
             if(direction==1){
             if(_close>top){active=false;return(1);}
             if(_close<bottom){active=false;return(0);}
             }
           //bearish
           // If the current price of the current candle (third candle) is lower than the bottom of the engulfing pattern, the pattern is invalidated (active=false) and a Sell signal is returned (-1)
             else if(direction==-1){
             if(_close<bottom){active=false;return(-1);}
             if(_close>top){active=false;return(0);}
             }
           }
         return(0);
         }  
};

//and a rack of engulfs

struct engulfShelf{
anEngulf engulfs[];//this is our collection
         engulfShelf(void){reset();}
        ~engulfShelf(void){reset();}
    void reset(){
         ArrayFree(engulfs);
         } 
    char read_bars(double b1Open,
                   double b1Close,
                   datetime b1Time,
                   double b2Open,
                   double b2Close,
                   datetime b2Time,
                   double b3Close,
                   datetime b3Time_now){
         //bullish engulfing pattern check 
           if(b2Close>b2Open){
             if(b1Close<b1Open){
               if(b2Close>b1Open){
                 if(b2Open<b1Close){
                   //add engulfing pattern to collection 
                     int ix=add_engulf();
                     engulfs[ix].setup_bullish(b3Time_now,b1Time,b2Time,b2Close,b2Open);
                   }
                 }
               }
             }
         //bearish engulfing pattern check 
           if(b2Close<b2Open){
             if(b1Close>b1Open){
               if(b2Close<b1Open){
                 if(b2Open>b1Close){
                   //add engulfing pattern to collection
                     int ix=add_engulf();
                     engulfs[ix].setup_bearish(b3Time_now,b1Time,b2Time,b2Open,b2Close);
                   }
                 }
               }
             }  
         //0 no signal
         //1 only buy
         //-1 only sell
         //2 both   
           char signal=0;
           for(int i=0;i<ArraySize(engulfs);i++){
           char local_signal=engulfs[i].maintain(b3Close,b3Time_now);
           //if(local_signal!=0){
           //  if(signal==0){signal=local_signal;}
           //  else if(signal==1){  // check for bullish engulf
           //         if(local_signal==-1){signal=2;}
           //         }
           //  else if(signal==-1){  // check for bearish engulf
           //         if(local_signal==1){signal=2;}
           //         }
           //  }
           //}
           
           if (local_signal != 0){
                if (local_signal == 0){
                    signal = local_signal; 
                } 
                else if (local_signal == 1){   // check for bullish engulf
                    signal = local_signal;
                }
                 else if (local_signal == -1){   // check for bearish engulf
                    signal = local_signal;
                }
            }

          if(local_signal!=0){
             if(signal==0){signal=local_signal;}
             else if(signal==1){  // check for bullish engulf
                    if(local_signal==-1){signal=2;}
                    }
             else if(signal==-1){  // check for bearish engulf
                    if(local_signal==1){signal=2;}
                    }
             }
           } 

           int from=ArraySize(engulfs)-1;
           for(int i=from;i>=0;i--){
           if(!engulfs[i].is_active()){
             remove(i);
             }
           }
         return(signal);
         }
     int add_engulf(){
         int ns=ArraySize(engulfs)+1; //  arrays in MQL5 are zero-based (indexing starts from 0), adding 1 will create room for the new element at the end of the array
         ArrayResize(engulfs,ns,0);
         return(ns-1); // resizing the array to accommodate the new engulfing pattern, we want to return the index at which the new pattern was added
         }
     int remove(int ix){
         int ns=ArraySize(engulfs)-1;
         engulfs[ix]=engulfs[ns];
         ArrayResize(engulfs,ns,0);
         return(ns);
         }
         

      double priceCheck(){
           
       datetime candleTime = iTime(_Symbol, PERIOD_H4, 0); 
       int prevBar = iBarShift(_Symbol, PERIOD_H4, candleTime); // Get the bar index
       double closePrice = iClose(_Symbol, PERIOD_H4, prevBar); // Get the close price
       
       return closePrice;
     }

};

engulfShelf E;

int OnInit()
  {
  E.reset();
//--- indicator buffers mapping
   SetIndexBuffer(0,BuyBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,SellBuffer,INDICATOR_DATA);
   SetIndexBuffer(2, indvalue, INDICATOR_DATA);
//--- setting a code from the Wingdings charset as the property of PLOT_ARROW
   PlotIndexSetInteger(0,PLOT_ARROW,233);
   PlotIndexSetInteger(0, PLOT_ARROW_SHIFT, 25);
   PlotIndexSetInteger(1,PLOT_ARROW,234);
   PlotIndexSetInteger(1, PLOT_ARROW_SHIFT, -25);
//---
   ma_handle = iMA(_Symbol, PERIOD_CURRENT, 20, 0, MODE_SMMA, PRICE_CLOSE);
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
  int from=prev_calculated;
  
  if(from==0){from=3;} // If from is equal to 0, it means that the indicator is being calculated for the first time, so from is adjusted to 3 (to avoid issues with indexing)
  
  max_bars = Bars(Symbol(), Period());
  
  // Calculate the number of bars to copy
  int to_copy = rates_total - prev_calculated;
  ArrayResize(maBuffer, to_copy);
    
  CopyBuffer(ma_handle, 0, 0, to_copy, maBuffer); // Copy the last value from the Moving Average buffer
  if (to_copy <= 0){
      to_copy = max_bars;
  }
  
  double range = ma_point_range * _Point; // Define the range around the MA value  
  
  for(int i=from;i<=rates_total-2;i++){
     char signal=E.read_bars(open[i-2],close[i-2],time[i-2],open[i-1],close[i-1],time[i-1],close[i],time[i]);
     indvalue[i] = maBuffer[i];
     
     if (signal == 1 && MathAbs(close[i] - indvalue[i]) <= range && close[i-2] > (indvalue[i] + 5*_Point)){
         BuyBuffer[i] = close[i];
     }
     else if (signal == -1 && MathAbs(close[i] - indvalue[i]) <= range && close[i-2] < (indvalue[i] - 5*_Point)){
         SellBuffer[i] = close[i];
     }
  } 

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+


void OnDeinit(const int reason){
    // Free the indicator buffers to release memory
    ArrayFree(BuyBuffer);
    ArrayFree(SellBuffer);
}
